Index: trunk/src/os2ahci/Makefile
===================================================================
--- trunk/src/os2ahci/Makefile	(revision 193)
+++ trunk/src/os2ahci/Makefile	(revision 196)
@@ -12,5 +12,5 @@
 # Define default build version if not specified in environment
 BLD_MAJOR=2
-BLD_MINOR=04 # must be 2 digits
+BLD_MINOR=05 # must be 2 digits
 BLD_REV=0 # not used at this time
 
Index: trunk/src/os2ahci/ReadMe.txt
===================================================================
--- trunk/src/os2ahci/ReadMe.txt	(revision 193)
+++ trunk/src/os2ahci/ReadMe.txt	(revision 196)
@@ -1,3 +1,3 @@
-AHCI Driver for OS/2 v2.04
+AHCI Driver for OS/2 v2.05
 
 Introduction
@@ -16,5 +16,5 @@
 Copyright (c) 2011 thi.guten Software Development
 Copyright (c) 2011 Mensys B.V.
-Copyright (c) 2013-2017 David Azarewicz
+Copyright (c) 2013-2018 David Azarewicz
 
 Authors: Christian Mueller, Markus Thielen
@@ -379,4 +379,8 @@
 ==========
 
+v.2.05 05-Apr-2018 - David Azarewicz
+  Changes to debug output for debug versions.
+  Removed interrupt reqirement on init.
+
 v.2.04 06-Dec-2017 - David Azarewicz
   Cosmetic changes to user display.
Index: trunk/src/os2ahci/ahci.c
===================================================================
--- trunk/src/os2ahci/ahci.c	(revision 193)
+++ trunk/src/os2ahci/ahci.c	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
@@ -631,5 +631,5 @@
     {
       /* we have a valid IDENTIFY or IDENTIFY_PACKET response */
-      DHEXDUMP(2,id_buf, ATA_ID_WORDS * sizeof(u16), "ATA_IDENTIFY%s results:\n", (is_ata) ? "" : "_PACKET");
+      DHEXDUMP(5,id_buf, ATA_ID_WORDS * sizeof(u16), "ATA_IDENTIFY%s results:\n", (is_ata) ? "" : "_PACKET");
       ahci_setup_device(ai, p, 0, id_buf);
     }
@@ -1734,5 +1734,5 @@
   int d = iorb_unit_device(pIorb);
 
-  DHEXDUMP(0,Far16ToFlat(((IORB_ADAPTER_PASSTHRU *)pIorb)->pControllerCmd),
+  DHEXDUMP(5,Far16ToFlat(((IORB_ADAPTER_PASSTHRU *)pIorb)->pControllerCmd),
         ((IORB_ADAPTER_PASSTHRU *)pIorb)->ControllerCmdLen,
         "ahci_execute_cdb(%d.%d.%d): ", a, p, d);
@@ -1760,5 +1760,5 @@
   int d = iorb_unit_device(pIorb);
 
-  DHEXDUMP(0,Far16ToFlat(((IORB_ADAPTER_PASSTHRU *)pIorb)->pControllerCmd),
+  DHEXDUMP(5,Far16ToFlat(((IORB_ADAPTER_PASSTHRU *)pIorb)->pControllerCmd),
         ((IORB_ADAPTER_PASSTHRU *)pIorb)->ControllerCmdLen,
         "ahci_execute_ata(%d.%d.%d): ", a, p, d);
Index: trunk/src/os2ahci/ahci.h
===================================================================
--- trunk/src/os2ahci/ahci.h	(revision 193)
+++ trunk/src/os2ahci/ahci.h	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/apm.c
===================================================================
--- trunk/src/os2ahci/apm.c	(revision 193)
+++ trunk/src/os2ahci/apm.c	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Portions copyright (c) 2013-2016 David Azarewicz
+ * Portions copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/ata.c
===================================================================
--- trunk/src/os2ahci/ata.c	(revision 193)
+++ trunk/src/os2ahci/ata.c	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
@@ -287,5 +287,5 @@
 
   #ifdef DEBUG
-  if ((D32g_DbgLevel >= 7) || (atapi_cmd != NULL))
+  if ((D32g_DbgLevel >= 5) /*|| (atapi_cmd != NULL)*/)
   {
     DPRINTF(0,"ATA command for %d.%d.%d, slot %d:\n", ad_no(ai), p, d, slot);
@@ -544,5 +544,5 @@
   if (rc) return 0;
 
-  DHEXDUMP(3,pDLA, sizeof(DLA_Table_Sector), "DLA sector %d:\n", sector-1);
+  DHEXDUMP(5,pDLA, sizeof(DLA_Table_Sector), "DLA sector %d:\n", sector-1);
 
   if ((pDLA->DLA_Signature1 == DLA_TABLE_SIGNATURE1) && (pDLA->DLA_Signature2 == DLA_TABLE_SIGNATURE2)) {
@@ -1161,5 +1161,5 @@
                 | ((u16) fis[13] << 8);
 
-  DHEXDUMP(0,cmd, sizeof(*cmd), "ahci_execute_ata_pp(): cmd after completion:\n");
+  DHEXDUMP(5,cmd, sizeof(*cmd), "ahci_execute_ata_pp(): cmd after completion:\n");
 
   /* signal completion to interrupt handler */
Index: trunk/src/os2ahci/ata.h
===================================================================
--- trunk/src/os2ahci/ata.h	(revision 193)
+++ trunk/src/os2ahci/ata.h	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/atapi.c
===================================================================
--- trunk/src/os2ahci/atapi.c	(revision 193)
+++ trunk/src/os2ahci/atapi.c	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
@@ -373,5 +373,5 @@
   ATAPI_SENSE_DATA *psd = (ATAPI_SENSE_DATA *) aws->buf;
 
-  DHEXDUMP(0,psd, sizeof(*psd), "sense buffer:\n");
+  DHEXDUMP(5,psd, sizeof(*psd), "sense buffer:\n");
 
   if ((pIorb->RequestControl & IORB_REQ_STATUSBLOCK) &&
Index: trunk/src/os2ahci/atapi.h
===================================================================
--- trunk/src/os2ahci/atapi.h	(revision 193)
+++ trunk/src/os2ahci/atapi.h	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/ctxhook.c
===================================================================
--- trunk/src/os2ahci/ctxhook.c	(revision 193)
+++ trunk/src/os2ahci/ctxhook.c	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/ioctl.c
===================================================================
--- trunk/src/os2ahci/ioctl.c	(revision 193)
+++ trunk/src/os2ahci/ioctl.c	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/ioctl.h
===================================================================
--- trunk/src/os2ahci/ioctl.h	(revision 193)
+++ trunk/src/os2ahci/ioctl.h	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/os2ahci.c
===================================================================
--- trunk/src/os2ahci/os2ahci.c	(revision 193)
+++ trunk/src/os2ahci/os2ahci.c	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/os2ahci.def.template
===================================================================
--- trunk/src/os2ahci/os2ahci.def.template	(revision 193)
+++ 	(revision )
@@ -1,16 +1,0 @@
-library os2ahci
-protmode
-
-segments
-  'DEVHDR'      CLASS 'DATA'
-  '_DATA'       CLASS 'DATA'
-  'LIBDATA'     CLASS 'DATA'
-  'CONST'       CLASS 'CONST'
-  '_BSS'        CLASS 'BSS'
-  'c_common'    CLASS 'BSS'
-  '_z_data'     CLASS 'BSS'
-  '_TEXT'       CLASS 'CODE' IOPL
-  'CODE'        CLASS 'CODE' IOPL
-  'LIBCODE'     CLASS 'CODE' IOPL
-  'RMCode'      CLASS 'CODE' IOPL
-  '_z_text'     CLASS 'CODE' IOPL
Index: trunk/src/os2ahci/os2ahci.h
===================================================================
--- trunk/src/os2ahci/os2ahci.h	(revision 193)
+++ trunk/src/os2ahci/os2ahci.h	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
Index: trunk/src/os2ahci/pci.c
===================================================================
--- trunk/src/os2ahci/pci.c	(revision 193)
+++ trunk/src/os2ahci/pci.c	(revision 196)
@@ -4,5 +4,5 @@
  * Copyright (c) 2011 thi.guten Software Development
  * Copyright (c) 2011 Mensys B.V.
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  * Authors: Christian Mueller, Markus Thielen
@@ -477,4 +477,5 @@
   pin = (int) ((val >> 8) & 0xff);
 
+  #if 0
   i = 1;
   if (irq==0 || irq==255) i = 0;
@@ -489,4 +490,5 @@
   }
   if (i==0) return;
+  #endif
 
   /* make sure we got room in the adapter information array */
Index: trunk/src/os2ahci/thunk.asm
===================================================================
--- trunk/src/os2ahci/thunk.asm	(revision 193)
+++ trunk/src/os2ahci/thunk.asm	(revision 196)
@@ -1,4 +1,4 @@
 ; Thunking for ahci32 driver
-; Copyright (c) 2016 David Azarewicz
+; Copyright (c) 2018 David Azarewicz
 ; Author: David Azarewicz <david@88watts.net>
 
Index: trunk/src/os2ahci/trace.c
===================================================================
--- trunk/src/os2ahci/trace.c	(revision 193)
+++ trunk/src/os2ahci/trace.c	(revision 196)
@@ -1,5 +1,5 @@
 /******************************************************************************
  *
- * Copyright (c) 2013-2016 David Azarewicz
+ * Copyright (c) 2013-2018 David Azarewicz
  *
  */