Index: /trunk/openjdk/jdk/make/java/instrument/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/instrument/Makefile	(revision 202)
+++ /trunk/openjdk/jdk/make/java/instrument/Makefile	(revision 203)
@@ -31,4 +31,6 @@
 LIBRARY = instrument
 PRODUCT = sun
+
+LIBRARY_SHORT = instrmnt
 
 # Configure the CFLAGS for this library.  Use static binding so that there
Index: /trunk/openjdk/jdk/make/java/java_crw_demo/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/java_crw_demo/Makefile	(revision 202)
+++ /trunk/openjdk/jdk/make/java/java_crw_demo/Makefile	(revision 203)
@@ -28,4 +28,6 @@
 PRODUCT = sun
 LIBRARY_OUTPUT = java_crw_demo
+
+LIBRARY_SHORT = javacrwd
 
 # Configure the CFLAGS for this library.
Index: /trunk/openjdk/jdk/make/java/management/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/java/management/Makefile	(revision 202)
+++ /trunk/openjdk/jdk/make/java/management/Makefile	(revision 203)
@@ -28,4 +28,7 @@
 LIBRARY = management
 PRODUCT = java
+
+LIBRARY_SHORT = mngemnt
+
 include $(BUILDDIR)/common/Defs.gmk
 
Index: /trunk/openjdk/jdk/make/sun/image/generic/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/image/generic/Makefile	(revision 202)
+++ /trunk/openjdk/jdk/make/sun/image/generic/Makefile	(revision 203)
@@ -32,4 +32,7 @@
 LIBRARY = mlib_image
 PRODUCT = sun
+
+LIBRARY_SHORT = mlibimg
+
 include $(BUILDDIR)/common/Defs.gmk
 
Index: /trunk/openjdk/jdk/make/sun/security/mscapi/Makefile
===================================================================
--- /trunk/openjdk/jdk/make/sun/security/mscapi/Makefile	(revision 202)
+++ /trunk/openjdk/jdk/make/sun/security/mscapi/Makefile	(revision 203)
@@ -93,4 +93,6 @@
 LIBRARY = sunmscapi
 PRODUCT = sun
+
+LIBRARY_SHORT = smscapi
 
 #
Index: /trunk/openjdk/jdk/src/share/classes/sun/awt/image/ImagingLib.java
===================================================================
--- /trunk/openjdk/jdk/src/share/classes/sun/awt/image/ImagingLib.java	(revision 202)
+++ /trunk/openjdk/jdk/src/share/classes/sun/awt/image/ImagingLib.java	(revision 203)
@@ -97,5 +97,9 @@
                     if (arch == null || !arch.startsWith("sparc")) {
                         try {
-                            System.loadLibrary("mlib_image");
+                            if (System.getProperty("os.name").startsWith("OS/2")) {
+                                System.loadLibrary("mlibimg");
+                            } else {
+                                System.loadLibrary("mlib_image");
+                            }
                         } catch (UnsatisfiedLinkError e) {
                             return Boolean.FALSE;
Index: /trunk/openjdk/jdk/src/share/classes/sun/instrument/InstrumentationImpl.java
===================================================================
--- /trunk/openjdk/jdk/src/share/classes/sun/instrument/InstrumentationImpl.java	(revision 202)
+++ /trunk/openjdk/jdk/src/share/classes/sun/instrument/InstrumentationImpl.java	(revision 203)
@@ -272,5 +272,9 @@
 
     static {
-        System.loadLibrary("instrument");
+        if (System.getProperty("os.name").startsWith("OS/2")) {
+            System.loadLibrary("instrmnt");
+        } else {
+            System.loadLibrary("instrument");
+        }
     }
 
Index: /trunk/openjdk/jdk/src/share/classes/sun/management/ManagementFactory.java
===================================================================
--- /trunk/openjdk/jdk/src/share/classes/sun/management/ManagementFactory.java	(revision 202)
+++ /trunk/openjdk/jdk/src/share/classes/sun/management/ManagementFactory.java	(revision 203)
@@ -483,5 +483,9 @@
 
     static {
-        AccessController.doPrivileged(new LoadLibraryAction("management"));
+        if (System.getProperty("os.name").startsWith("OS/2")) {
+            AccessController.doPrivileged(new LoadLibraryAction("mngemnt"));
+        } else {
+            AccessController.doPrivileged(new LoadLibraryAction("management"));
+        }
         jvm = new VMManagementImpl();
     }
Index: /trunk/openjdk/jdk/src/share/classes/sun/tools/attach/HotSpotVirtualMachine.java
===================================================================
--- /trunk/openjdk/jdk/src/share/classes/sun/tools/attach/HotSpotVirtualMachine.java	(revision 202)
+++ /trunk/openjdk/jdk/src/share/classes/sun/tools/attach/HotSpotVirtualMachine.java	(revision 203)
@@ -101,5 +101,9 @@
         }
         try {
-            loadAgentLibrary("instrument", args);
+            if (System.getProperty("os.name").startsWith("OS/2")) {
+                loadAgentLibrary("instrmnt", args);
+            } else {
+                loadAgentLibrary("instrument", args);
+            }
         } catch (AgentLoadException x) {
             throw new InternalError("instrument library is missing in target VM");
Index: /trunk/openjdk/jdk/src/share/demo/jvmti/hprof/hprof_init.c
===================================================================
--- /trunk/openjdk/jdk/src/share/demo/jvmti/hprof/hprof_init.c	(revision 202)
+++ /trunk/openjdk/jdk/src/share/demo/jvmti/hprof/hprof_init.c	(revision 203)
@@ -2030,6 +2030,9 @@
 
         /* Load the library or get the handle to it */
+#ifdef OS2        
+        gdata->java_crw_demo_library = load_library("javacrwd");
+#else
         gdata->java_crw_demo_library = load_library("java_crw_demo");
-
+#endif
         { /* "java_crw_demo" */
             static char *symbols[]  = JAVA_CRW_DEMO_SYMBOLS;
Index: /trunk/openjdk/jdk/src/windows/classes/sun/security/mscapi/SunMSCAPI.java
===================================================================
--- /trunk/openjdk/jdk/src/windows/classes/sun/security/mscapi/SunMSCAPI.java	(revision 202)
+++ /trunk/openjdk/jdk/src/windows/classes/sun/security/mscapi/SunMSCAPI.java	(revision 203)
@@ -51,5 +51,9 @@
         AccessController.doPrivileged(new PrivilegedAction() {
             public Object run() {
-                System.loadLibrary("sunmscapi");
+                if (System.getProperty("os.name").startsWith("OS/2")) {
+                    System.loadLibrary("smscapi");
+                } else {
+                    System.loadLibrary("sunmscapi");
+                }
                 return null;
             }
Index: /trunk/openjdk/jdk/src/windows/native/sun/windows/awt_Mlib.cpp
===================================================================
--- /trunk/openjdk/jdk/src/windows/native/sun/windows/awt_Mlib.cpp	(revision 202)
+++ /trunk/openjdk/jdk/src/windows/native/sun/windows/awt_Mlib.cpp	(revision 203)
@@ -49,6 +49,9 @@
          * initialize the pointers to required mlib routines.
          */
+#ifdef __WIN32OS2__         
+        hDLL = ::LoadLibrary(TEXT("mlibimg.dll"));
+#else
         hDLL = ::LoadLibrary(TEXT("mlib_image.dll"));
-
+#endif
         if (hDLL == NULL) {
             return MLIB_FAILURE;